import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class Hadamard extends Frame
{  public double currentX, currentY; // ݂̕`ʒu
   public Hadamard()
   {  setSize(600,600);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private int[][] HT_Mat(int N)
   {  int MX = (int)(Math.pow(2,N)) ; int [][] HMat= new int[MX][MX];
      HMat[0][0] = 1; int K = 1;
      for(int L = 1; L<= N; L++) 
      { for(int i = 0; i< K; i++)for(int j = 0; j< K; j++)
        { HMat[K + i][j    ] =   HMat[i][j];
          HMat[i    ][K + j] =   HMat[i][j];
          HMat[K + i][K + j] = - HMat[i][j];
        }
        K = K * 2;
      }
      return HMat;
   }
   private int CountChange(int [][] HMat, int K, int MX)
   { int CC = 0;  int ID = HMat[K][0];
     for(int j = 1; j< MX; j++)
           if(ID != HMat[K][j]){CC = CC + 1; ID = HMat[K][j];}
     return CC;
   }
   private void HT_Sort(int HMat[][], int N)
   {  int MX = (int)(Math.pow(2,N));
      for(int i = 0; i< MX - 1; i++)
      { int MXC = CountChange(HMat, i, MX); int ID = i;
        for(int j = i + 1; j< MX; j++)
        {   int MXP = CountChange(HMat, j, MX); 
            if( MXP < MXC){ ID = j; MXC = MXP;}
        }
        if(ID != i)
          for(int j =0; j<MX; j++)
          {  int TT = HMat[ID][j]; HMat[ID][j] = HMat[i][j]; HMat[i][j] = TT;}
      }
   }
   private double[] HT(double[] X,int [][]HMat, int Num)  //Hadamardϊ
   { double []Y=new double[Num+1];
     for(int i = 0;i < Num; i++)
     { Y[i] = 0;
       for(int j = 0; j < Num; j++) Y[i] += (double)HMat[i][j] * X[j];
     }
     Y[Num] = Y[0];
     return Y;
   }
   private double[] IHT(double[] Y,int [][]HMat, int Num) //tHadamardϊ
   { double []Z=new double[Num+1];
     for(int i = 0;i < Num; i++)
     { Z[i] = 0;
       for(int j = 0; j < Num; j++) Z[i] += (double)HMat[i][j] * Y[j];
     }
     Z[Num] = Z[0];
     for(int i = 0;i <= Num; i++) Z[i] /= (double) Num;
     return Z;
  }
   
  private double[] Pulse(int Num)
  { double []X = new double[Num+1];
    int N1= 3 * Num / 8; int N2 = 6 * Num / 8;
    for(int k = 0; k < Num; k++)
    { X[k]=-1; if(k >= N1 && k < N2) X[k] = 1;
    }
    X[Num] = X[0];
    return X;
  }


   public int Xpos(double X)
   {  return (int)(X*50)+100;}
   public int Ypos(double Y)
   {  return 400- (int)(Y*50);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }

   public void paint(Graphics g)
   { int KM=3;int Max =(int)(Math.pow(2,KM));
     int i,k,j; boolean Flag = false;
     int [][]HMat = HT_Mat(KM);
     for(i=0; i < Max; i++)for(j = 0; j < Max; j++)
          g.drawString("" + HMat[i][j],20+20*j,120+20*i);
     HT_Sort(HMat, KM);
     for(i=0; i < Max; i++)for(j = 0; j < Max; j++)
          g.drawString("" + HMat[i][j],200+20*j,120+20*i);
     double [] X  = Pulse(Max);
     double [] Y1 = HT (X,HMat, Max);
     double [] Y2 = IHT(Y1,HMat, Max);

     setTitle("A_}[ϊ");
     g.drawString("A_}[s",100,100);
     g.drawString("HT",210,400);
     g.drawString("IHT",210,500);
     
     g.setColor(new Color(0,0,255));
     
     Flag = false;
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.2, X[k]/2, Flag);
     Flag = false;
     g.setColor(new Color(255,0,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.2+3.5, Y1[k]/5, Flag);
     Flag = false;
     g.setColor(new Color(0,255,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.2, Y2[k]/2-2, Flag);
    
   } 
   public static void main(String[] args)
   {  Frame w = new Hadamard();
      w.setVisible(true);
   }
}
